#include "Button.h"

Button::Button() : label(NULL), x(0), y(0), width(0), height(0)
{
}

Button::~Button()
{
  free(label);
}

void Button::SetText(const wchar_t* label)
{
  free(this->label);
  this->label=NULL;

  if (label)
  {
    int len=wcslen(label)+1;
    this->label=(wchar_t*) malloc(2*len);
    wcscpy_s(this->label, len, label);
  }
}


void Button::Draw(HDC hdc)
{
  if (label)
  {
    ::SetTextColor(hdc, 0x0);
    ::SetTextAlign(hdc, TA_CENTER|TA_TOP);
    ::SetBkMode(hdc, TRANSPARENT);

    ::TextOut(hdc, x+(width/2), y+5, label, wcslen(label));
    ::MoveToEx(hdc, x, y, NULL);
    ::LineTo(hdc, x+width, y);
    ::LineTo(hdc, x+width, y+height);
    ::LineTo(hdc, x, y+height);
    ::LineTo(hdc, x, y);
  }
}

