#pragma once
#include <Windows.h>

class Button
{
public:
  Button();
  ~Button();

  void SetText(const wchar_t* label);
  bool HitTest(const int x, const int y);
  void SetWindowPos(const int x, const int y, const int width, const int height);
  void Draw(HDC hdc);

  int GetX();
  int GetY();
  int GetHeight();
  int GetWidth();

private:
  int x, y, width, height;
  wchar_t* label;
};

inline bool Button::HitTest(const int x, const int y)
{
  return (x>=this->x && x<=(this->x+width) && y>=this->y && y<=(this->y+height));
}

inline void Button::SetWindowPos(const int x, const int y, const int width, const int height)
{
  this->x=x;
  this->y=y;
  this->width=width;
  this->height=height;
}

inline int Button::GetX() { return x; }
inline int Button::GetY() { return y; }
inline int Button::GetWidth() { return width; }
inline int Button::GetHeight() { return height; }
