#pragma once
#include <Windows.h>
#include <NuiApi.h>

//#define NEAR_MODE
#define LO_RES_DEPTH
#define CLEAR_WORLD_PAIRS

#define IMAGE_RESOLUTION        NUI_IMAGE_RESOLUTION_640x480
#define COLOUR_FRAME_WIDTH      640
#define COLOUR_FRAME_HEIGHT     480

#ifdef LO_RES_DEPTH
  #define WORLD_SCALE           0.02f // x and y difference across pixels
  #define DEPTH_FRAME_WIDTH     320
  #define DEPTH_FRAME_HEIGHT    240
  #define DEPTH_RESOLUTION      NUI_IMAGE_RESOLUTION_320x240
#else
  #define WORLD_SCALE           0.01f // x and y difference across pixels
  #define DEPTH_FRAME_WIDTH     640
  #define DEPTH_FRAME_HEIGHT    480
  #define DEPTH_RESOLUTION      NUI_IMAGE_RESOLUTION_640x480
#endif

#define DEPTH_SCALE             0.05f//0.1f

#define PERSPECTIVE_CORRECTION  0.000178f

#ifdef NEAR_MODE
  #define Z_OFFSET            0//((NUI_IMAGE_DEPTH_MINIMUM_NEAR_MODE>>NUI_IMAGE_PLAYER_INDEX_SHIFT)*WORLD_SCALE*DEPTH_SCALE)
#else
  #define Z_OFFSET              ((NUI_IMAGE_DEPTH_MINIMUM>>NUI_IMAGE_PLAYER_INDEX_SHIFT)*WORLD_SCALE*DEPTH_SCALE)
#endif
//  #define Z_OFFSET              4.0f

#define INIT_DISTANCE_THRESHOLD 0.05f    // 5cm (WORLD_SCALE*7)  // used to determine if points are close enough within ICP
extern float DISTANCE_THRESHOLD;//=0.05f;
#define NORMAL_THRESHOLD        0.43              // +- 24.5 degrees
#define INV_NORMAL_THRESHOLD    0.908966f         //  =cos(NORMAL_THRESHOLD)
#define MAX_ITERATIONS          30                // max ICP iterations
#define MIN_ITERATIONS          3

#define DROP_RATE               50      // how many iterations of not seeing a point before it gets pruned

#define MATCH_DISTANCE          0.02f   // 1cm for a match - used to determine if two points are the same when merging

#define ITERATION_PRECISION     1e-5   // used to determine whether two iteration errors are close enough for there to be no change
