#pragma once

void CalcTransform(double* transform, const double* coss, const double* sins, const double* xyz);
void CalcInverseTransform(double* inverse, const double* coss, const double* sins, const double* xyz);
void MatMult(float* dest, const double* a, const int a_rows, const int a_cols, const float* b, const int b_rows, const int b_cols);
void MatMult(float* dest, const float* a, const int a_rows, const int a_cols, const float* b, const int b_rows, const int b_cols);
void MatMultTA_LT(double* dest, const double* a, const int a_rows, const int a_cols, const double* b, const int b_rows, const int b_cols);
void MatMultTA(double* dest, const double* a, const int a_rows, const int a_cols, const double* b, const int b_rows);

void CholeskyDecomposition(double* dest, const double* a, const int rows, const int cols);

void DumpMatrix(const wchar_t* filename, double* a, const int rows, const int cols);