#pragma once

#include "GLRenderer.h"
#include "CloudData.h"
#include <math.h>

struct PDTHREADINFO
{
  int index;
  VOID* parent;

  bool* alive;
  HANDLE alerts[2];   // 0=start; 1=end

  int noofpts;
  POINTDATA* pointdata;

  DWORD iteration;

  int additions, maxadd, updates;
  POINTDATA* addpts;
};

class PDUpdate
{
public:
  PDUpdate();
  ~PDUpdate();

  void SetNoOfThreads(const int n);
  void SetCloudData(CloudData* clouddata);

  POINTDATA* UpdatePointCloud(POINTDATA* frame, const float* transform, int* counts, POINTDATA* worlddata, int& noofwldpts, int& maxwldpts, const DWORD iteration, const bool findmatches);

private:
  bool alive;
  int noofthreads;
  HANDLE* threads, *alerts;
  PDTHREADINFO* threadinfo;

  bool findmatches;
  int framesize;
  float localminsq;

  CloudData* clouddata;
  const float* transform;

  void KillThreads();

  void UpdatePointCloudAux(PDTHREADINFO* info);

  friend DWORD WINAPI PDUpdateThread(LPVOID lpParameter);
};

inline void PDUpdate::SetCloudData(CloudData* clouddata)
{
  this->clouddata=clouddata;
}