#pragma once

#include "GLRenderer.h"
#include <Windows.h>
#include <stdio.h>

#define RECORDER_RECORD     1
#define RECORDER_PLAYBACK   2

class Recorder
{
public:
  Recorder(const wchar_t* filename, const int mode, const int framewidth, const int frameheight);
  ~Recorder();

  void WriteNewFrame();
  void WritePoint(const POINTDATA* point, const DWORD index);
  int GetFrameData(POINTDATA* point, const int width, const int height);
//  void WriteData(const BYTE* data, const int offset, const int len);
  void CloseRecorder();

private:
  int bufflen, buffpos;
  BYTE* buffer;

  int mode;
  bool recalibrate;

  FILE* file;
};

